# generated by datamodel-codegen:
#   filename:  MDS.json
#   timestamp: 2024-09-03T07:28:56+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import List, Optional

from pydantic import AnyUrl, BaseModel, Extra, Field, constr


class Type(Enum):
    Study = 'Study'
    Substudy = 'Substudy'
    Biobank = 'Biobank'
    Case_report_form = 'Case report form'
    Code_book = 'Code book'
    Data_dictionary = 'Data dictionary'
    Data_management_plan = 'Data management plan'
    Dataset = 'Dataset'
    Discussion_guide = 'Discussion guide'
    Informed_consent_form = 'Informed consent form'
    Interview_scheme_and_themes = 'Interview scheme and themes'
    Manual_of_operations__SOPs_ = 'Manual of operations (SOPs)'
    Observation_guide = 'Observation guide'
    Participant_tasks = 'Participant tasks'
    Patient_information_sheet = 'Patient information sheet'
    Questionnaire = 'Questionnaire'
    Registry = 'Registry'
    Secondary_data_source = 'Secondary data source'
    Statistical_analysis_plan = 'Statistical analysis plan'
    Study_protocol = 'Study protocol'
    Other_data_collection_instrument = 'Other data collection instrument'
    Other_study_document = 'Other study document'
    Other = 'Other'


class TypeGeneral(Enum):
    Audiovisual = 'Audiovisual'
    Book = 'Book'
    Book_chapter = 'Book chapter'
    Collection = 'Collection'
    Computational_notebook = 'Computational notebook'
    Conference_paper = 'Conference paper'
    Conference_proceeding = 'Conference proceeding'
    Data_paper = 'Data paper'
    Dataset = 'Dataset'
    Dissertation = 'Dissertation'
    Event = 'Event'
    Image = 'Image'
    Interactive_resource = 'Interactive resource'
    Journal = 'Journal'
    Journal_article = 'Journal article'
    Model = 'Model'
    Output_management_plan = 'Output management plan'
    Peer_review = 'Peer review'
    Physical_object = 'Physical object'
    Preprint = 'Preprint'
    Report = 'Report'
    Service = 'Service'
    Software = 'Software'
    Sound = 'Sound'
    Standard = 'Standard'
    Text = 'Text'
    Workflow = 'Workflow'
    Other = 'Other'


class Classification(BaseModel):
    class Config:
        extra = Extra.forbid

    type: Type = Field(
        ...,
        description='A term describing the resource.',
        example='',
        title='Type of the resource',
    )
    typeGeneral: Optional[TypeGeneral] = Field(
        None,
        description='Specific information about the form in which the [RESOURCE] is available.',
        example='',
        title='In what form is the [RESOURCE] available?',
    )


class Keyword(BaseModel):
    class Config:
        extra = Extra.forbid

    label: constr(min_length=1) = Field(
        ...,
        description='Keyword(s) describing the [RESOURCE].',
        example='SARS-CoV-2',
        title='Keyword',
    )
    code: Optional[AnyUrl] = Field(
        None,
        description='If known, the code of the keyword in the classification/vocabulary used.',
        example='http://id.nlm.nih.gov/mesh/D000086402',
        title='Code of the keyword',
    )


class Label(Enum):
    CC0_1_0__Creative_Commons_Zero_v1_0_Universal_ = (
        'CC0 1.0 (Creative Commons Zero v1.0 Universal)'
    )
    CC_BY_4_0__Creative_Commons_Attribution_4_0_International_ = (
        'CC BY 4.0 (Creative Commons Attribution 4.0 International)'
    )
    CC_BY_NC_4_0__Creative_Commons_Attribution_Non_Commercial_4_0_International_ = (
        'CC BY-NC 4.0 (Creative Commons Attribution Non Commercial 4.0 International)'
    )
    CC_BY_SA_4_0__Creative_Commons_Attribution_Share_Alike_4_0_International_ = (
        'CC BY-SA 4.0 (Creative Commons Attribution Share Alike 4.0 International)'
    )
    CC_BY_NC_SA_4_0__Creative_Commons_Attribution_Non_Commercial_Share_Alike_4_0_International_ = 'CC BY-NC-SA 4.0 (Creative Commons Attribution Non Commercial Share Alike 4.0 International)'
    All_rights_reserved = 'All rights reserved'
    Other = 'Other'
    Not_applicable = 'Not applicable'
    Not_assigned = 'Not assigned'
    Unknown = 'Unknown'


class Confirmations(BaseModel):
    class Config:
        extra = Extra.forbid

    authority: bool = Field(
        ...,
        description='Confirmation that the authors of the [RESOURCE] have authority to license it.',
        example='',
        title='Do you confirm that the authors of the [RESOURCE] have authority to license it?',
    )
    terms: bool = Field(
        ...,
        description='Confirmation that the authors of the [RESOURCE] have read and understood the terms of the chosen license.',
        example='',
        title='Do you confirm that the authors of the [RESOURCE] have read and understood the terms of the chosen license?',
    )
    irrevocability: bool = Field(
        ...,
        description='Confirmation that the authors of the [RESOURCE] understand that Creative Commons (CC) licensing is not revocable.',
        example='',
        title='Do you confirm that the authors of the [RESOURCE] understand that Creative Commons (CC) licensing is irrevocable?',
    )
    supportByLicensing: bool = Field(
        ...,
        description='Confirmation that NFDI4Health is allowed to license the document, i.e. to mark the [RESOURCE] with the license information.',
        example='',
        title='Do you confirm that the authors of the [RESOURCE] allow NFDI4Health to license the document?',
    )


class UseRights(BaseModel):
    class Config:
        extra = Extra.forbid

    label: Label = Field(
        ...,
        description='License defining the rights to (re-)use the [RESOURCE].',
        example='',
        title='License',
    )
    link: Optional[AnyUrl] = Field(
        None,
        description='Link to the selected license.',
        example='',
        title='URL of the license',
    )
    confirmations: Optional[Confirmations] = Field(
        None,
        description='Group of items applicable only if a Creative Commons license is selected.',
        example='',
        title='Licensing confirmations',
    )
    description: Optional[str] = Field(
        None,
        description='Any additional descriptive information explaining terms and conditions to (re-)use the [RESOURCE].',
        example='',
        title='Additional information about use rights',
    )


class NonStudyDetails(BaseModel):
    class Config:
        extra = Extra.forbid

    version: Optional[str] = Field(
        None,
        description='If applicable, the version number of the [RESOURCE].',
        example='',
        title='Version',
    )
    format: Optional[str] = Field(
        None,
        description='If applicable, the file format of the [RESOURCE] (e.g., XML, PDF, XLSX, etc.).',
        example='PDF',
        title='Format',
    )
    useRights: Optional[UseRights] = Field(
        None,
        description='Group of items providing information about the rights to (re-)use the [RESOURCE].',
        example='',
        title='(Re-)use rights',
    )


class NameType(Enum):
    Personal = 'Personal'
    Organisational = 'Organisational'


class Type1(Enum):
    Contact = 'Contact'
    Creator_Author = 'Creator/Author'
    Funder__public_ = 'Funder (public)'
    Funder__private_ = 'Funder (private)'
    Sponsor__primary_ = 'Sponsor (primary)'
    Sponsor__secondary_ = 'Sponsor (secondary)'
    Sponsor_Investigator = 'Sponsor-Investigator'
    Research_group = 'Research group'
    Data_collector = 'Data collector'
    Data_curator = 'Data curator'
    Data_manager = 'Data manager'
    Distributor = 'Distributor'
    Hosting_institution = 'Hosting institution'
    Producer = 'Producer'
    Publisher = 'Publisher'
    Registration_agency = 'Registration agency'
    Registration_authority = 'Registration authority'
    Rights_holder = 'Rights holder'
    Supervisor = 'Supervisor'
    Other = 'Other'


class Organisational(BaseModel):
    class Config:
        extra = Extra.forbid

    type: Type1 = Field(
        ...,
        description='Contributor type an organisation, institution or group fulfills. For example, this can be a sponsor of the study or a group of authors of the document.',
        example='',
        title='Contributor type',
    )
    fundingIds: Optional[str] = Field(
        None,
        description='Identifier(s) assigned by a funder to the [RESOURCE].',
        example='',
        title='Funding identifier(s)',
    )
    name: constr(min_length=1) = Field(
        ...,
        description='Name of the organisation, institution or group.',
        example='',
        title='Name of the organisation/institution/group',
    )


class Type2(Enum):
    Contact = 'Contact'
    Principal_investigator = 'Principal investigator'
    Creator_Author = 'Creator/Author'
    Sponsor__primary_ = 'Sponsor (primary)'
    Sponsor__secondary_ = 'Sponsor (secondary)'
    Sponsor_Investigator = 'Sponsor-Investigator'
    Data_collector = 'Data collector'
    Data_curator = 'Data curator'
    Data_manager = 'Data manager'
    Editor = 'Editor'
    Producer = 'Producer'
    Project_leader = 'Project leader'
    Project_manager = 'Project manager'
    Project_member = 'Project member'
    Related_person = 'Related person'
    Researcher = 'Researcher'
    Rights_holder = 'Rights holder'
    Supervisor = 'Supervisor'
    Work_package_leader = 'Work package leader'
    Other = 'Other'


class Scheme(Enum):
    ORCID = 'ORCID'
    ROR = 'ROR'
    GRID = 'GRID'
    ISNI = 'ISNI'


class Identifier(BaseModel):
    class Config:
        extra = Extra.forbid

    identifier: constr(min_length=1) = Field(
        ...,
        description='Digital identifier according to a specific scheme that uniquely identifies the person.',
        example='0000-0003-1379-7023',
        title='Identifier',
    )
    scheme: Scheme = Field(
        ...,
        description='Type of the identifier scheme reported.',
        example='ORCID',
        title='Scheme',
    )


class Personal(BaseModel):
    class Config:
        extra = Extra.forbid

    type: Type2 = Field(
        ...,
        description='Contributor type a person fulfills. For example, this can be a principal investigator of a study or an author of a document.',
        example='',
        title='Contributor type',
    )
    givenName: constr(min_length=1) = Field(
        ..., description='Given name of the person.', example='', title='Given name'
    )
    familyName: constr(min_length=1) = Field(
        ...,
        description='Family name(s) of the person.',
        example='',
        title='Family name(s)',
    )
    identifiers: Optional[List[Identifier]] = Field(
        None,
        description='Group of items providing information about digital identifiers of the person.',
        example='',
        min_items=1,
        title='Digital identifier(s)',
    )


class Scheme1(Enum):
    ROR = 'ROR'
    GRID = 'GRID'
    ISNI = 'ISNI'


class Identifier1(BaseModel):
    class Config:
        extra = Extra.forbid

    identifier: constr(min_length=1) = Field(
        ...,
        description='Digital identifier according to a specific scheme that uniquely identifies the organisation.',
        example='0259fwx54',
        title='Identifier',
    )
    scheme: Scheme1 = Field(
        ...,
        description='Type of the identifier scheme reported.',
        example='ROR',
        title='Scheme',
    )


class Affiliation(BaseModel):
    class Config:
        extra = Extra.forbid

    name: constr(min_length=1) = Field(
        ...,
        description='Name of the organisation associated with the contributor.',
        example='',
        title='Name',
    )
    address: Optional[str] = Field(
        None,
        description='Address of the organisation associated with the contributor.',
        example='Gleueler Straße 60, 50931, Cologne, Germany',
        title='Address',
    )
    webpage: Optional[AnyUrl] = Field(
        None,
        description='Web page of the organisation associated with the contributor.',
        example='',
        title='Web page',
    )
    identifiers: Optional[List[Identifier1]] = Field(
        None,
        description='Group of items providing information about identifiers of the organisation.',
        example='',
        min_items=1,
        title='Digital identifier(s)',
    )


class Contributor(BaseModel):
    class Config:
        extra = Extra.forbid

    nameType: NameType = Field(
        ...,
        description='Indication whether the contribution was made by person(s) or organisation(s)/institution(s)/group(s).',
        example='',
        title='Is it a personal or organisational contribution?',
    )
    organisational: Optional[Organisational] = Field(
        None,
        description='Group of items providing information about group(s) of persons, institution(s) or organisation(s) contributing to the [RESOURCE].',
        example='',
        title='Details about the contributing organisation(s)/institution(s)/group(s)',
    )
    personal: Optional[Personal] = Field(
        None,
        description='Group of items providing information about person(s) contributing to the [RESOURCE].',
        example='',
        title='Details about the contributing person(s)',
    )
    email: Optional[str] = Field(
        None,
        description='Email address of the person, group of persons or institution/organisation.',
        example='',
        title='Email address',
    )
    phone: Optional[str] = Field(
        None,
        description='Phone number of the person, group of persons or institution/organisation.',
        example='+49 (0)153 1112233',
        title='Phone number',
    )
    affiliations: Optional[List[Affiliation]] = Field(
        None,
        description='Group of items providing further information about the organisation(s) associated with the contributor.',
        example='',
        min_items=1,
        title='Organisation(s) associated with the contributor',
    )


class Scheme2(Enum):
    DRKS = 'DRKS'
    NCT__ClinicalTrials_gov_ = 'NCT (ClinicalTrials.gov)'
    ISRCTN = 'ISRCTN'
    EudraCT = 'EudraCT'
    EUDAMED = 'EUDAMED'
    UTN = 'UTN'
    KonsortSWD = 'KonsortSWD'
    MDM_Portal = 'MDM Portal'
    Other = 'Other'


class IdsAlternativeItem(BaseModel):
    class Config:
        extra = Extra.forbid

    scheme: Scheme2 = Field(
        ...,
        description='Type/name of the system where the given [RESOURCE] is already registered.',
        example='DRKS',
        title='Type of the registry',
    )
    identifier: constr(min_length=1) = Field(
        ...,
        description='Identifier (ID) assigned to the given [RESOURCE] by another registering system, e.g. by a registry of clinical trials or a data repository.',
        example='ISRCTN91495258',
        title='Identifier',
    )


class Scheme3(Enum):
    DOI = 'DOI'
    URL = 'URL'
    arXiv = 'arXiv'
    EAN13 = 'EAN13'
    EISSN = 'EISSN'
    Handle = 'Handle'
    ISBN = 'ISBN'
    ISSN = 'ISSN'
    ISTC = 'ISTC'
    LISSN = 'LISSN'
    LSID = 'LSID'
    PMID = 'PMID'
    PURL = 'PURL'
    URN = 'URN'
    w3id = 'w3id'
    Other = 'Other'


class RelationType(Enum):
    A_is_cited_by_B = 'A is cited by B'
    A_cites_B = 'A cites B'
    A_is_supplement_to_B = 'A is supplement to B'
    A_is_supplemented_by_B = 'A is supplemented by B'
    A_is_continued_by_B = 'A is continued by B'
    A_continues_B = 'A continues B'
    A_is_described_by_B = 'A is described by B'
    A_describes_B = 'A describes B'
    A_has_metadata_B = 'A has metadata B'
    A_is_metadata_for_B = 'A is metadata for B'
    A_has_version_B = 'A has version B'
    A_is_version_of_B = 'A is version of B'
    A_is_new_version_of_B = 'A is new version of B'
    A_is_previous_version_of_B = 'A is previous version of B'
    A_is_part_of_B = 'A is part of B'
    A_has_part_B = 'A has part B'
    A_is_referenced_by_B = 'A is referenced by B'
    A_references_B = 'A references B'
    A_is_documented_by_B = 'A is documented by B'
    A_documents_B = 'A documents B'
    A_is_compiled_by_B = 'A is compiled by B'
    A_compiles_B = 'A compiles B'
    A_is_variant_form_of_B = 'A is variant form of B'
    A_is_original_form_of_B = 'A is original form of B'
    A_is_identical_to_B = 'A is identical to B'
    A_is_reviewed_by_B = 'A is reviewed by B'
    A_reviews_B = 'A reviews B'
    A_is_derived_from_B = 'A is derived from B'
    A_is_source_of_B = 'A is source of B'
    A_is_required_by_B = 'A is required by B'
    A_requires_B = 'A requires B'
    A_is_obsoleted_by_B = 'A is obsoleted by B'
    A_obsoletes_B = 'A obsoletes B'


class Id(BaseModel):
    class Config:
        extra = Extra.forbid

    identifier: constr(min_length=1) = Field(
        ...,
        description='Identifier (ID) related to, or associated with, the [RESOURCE] being registered. These can be IDs of related publications, datasets, study documents, web pages, etc.',
        example='10.4126/FRL01-006431467',
        title='Identifier of the related resource',
    )
    scheme: Scheme3 = Field(
        ...,
        description='Type of the identifier of the related resource.',
        example='DOI',
        title='Type of the identifier',
    )
    relationType: RelationType = Field(
        ...,
        description='Relationship between the [RESOURCE] being registered (A) and the related resource (B).',
        example='A is part of B',
        title='Relationship between this [RESOURCE] (A) and the related resource (B)',
    )
    typeGeneral: Optional[TypeGeneral] = Field(
        None,
        description='Type of the related resource, e.g. journal article, dataset, text, etc.',
        example='Text',
        title='Type of the related resource',
    )


class IdsNfdi4healthItem(BaseModel):
    class Config:
        extra = Extra.forbid

    identifier: constr(min_length=1) = Field(
        ...,
        description='Identifier (ID) of the related resource assigned on this portal.',
        example='39',
        title='Identifier of the related resource',
    )
    date: Optional[datetime] = Field(
        None,
        description='Date when the identifier of the related resource was assigned.',
        example='',
        title='Date of ID assignment',
    )
    relationType: Optional[RelationType] = Field(
        None,
        description='Relationship between the [RESOURCE] being registered (A) and the related resource (B).',
        example='',
        title='Relationship between this [RESOURCE] (A) and the related resource (B)',
    )


class DataSource(Enum):
    Automatically_uploaded__ClinicalTrials_gov = (
        'Automatically uploaded: ClinicalTrials.gov'
    )
    Automatically_uploaded__DRKS = 'Automatically uploaded: DRKS'
    Automatically_uploaded__ICTRP = 'Automatically uploaded: ICTRP'
    Automatically_uploaded__MDM_Portal = 'Automatically uploaded: MDM Portal'
    Automatically_uploaded__Other = 'Automatically uploaded: Other'
    Manually_collected = 'Manually collected'


class VerificationUser(Enum):
    Names_from_the_list_of_users = 'Names from the list of users'


class FirstSubmittedUser(Enum):
    Names_from_the_list_of_users = 'Names from the list of users'


class FirstPostedUser(Enum):
    Names_from_the_list_of_users = 'Names from the list of users'


class LastUpdateSubmittedUser(Enum):
    Names_from_the_list_of_users = 'Names from the list of users'


class LastUpdatePostedUser(Enum):
    Names_from_the_list_of_users = 'Names from the list of users'


class Provenance(BaseModel):
    class Config:
        extra = Extra.forbid

    dataSource: DataSource = Field(
        ...,
        description='Source of information about the [RESOURCE] and the way it was uploaded/collected.',
        example='',
        title='Source of information about the [RESOURCE]',
    )
    verificationDate: Optional[datetime] = Field(
        None,
        description='Date on which the responsible party last verified the information about the [RESOURCE], even if no additional or updated information is being submitted.',
        example='',
        title='Last verified on',
    )
    verificationUser: Optional[VerificationUser] = Field(
        None,
        description='User who last verified the information about the [RESOURCE].',
        example='',
        title='Last verified by',
    )
    firstSubmittedDate: Optional[datetime] = Field(
        None,
        description='Date when the [RESOURCE] was first submitted for publication.',
        example='',
        title='First submitted on',
    )
    firstSubmittedUser: Optional[FirstSubmittedUser] = Field(
        None,
        description='User who first submitted the [RESOURCE] for publication.',
        example='',
        title='First submitted by',
    )
    firstPostedDate: Optional[datetime] = Field(
        None,
        description='Date when the [RESOURCE] was first posted/published.',
        example='',
        title='First posted/published on',
    )
    firstPostedUser: Optional[FirstPostedUser] = Field(
        None,
        description='User who first posted/published the [RESOURCE].',
        example='',
        title='First posted/published by',
    )
    lastUpdateSubmittedDate: Optional[datetime] = Field(
        None,
        description='Date when the last update of the [RESOURCE] was submitted for publication.',
        example='',
        title='Last update submitted on',
    )
    lastUpdateSubmittedUser: Optional[LastUpdateSubmittedUser] = Field(
        None,
        description='User who submitted the last update of the [RESOURCE].',
        example='',
        title='Last updated submitted by',
    )
    lastUpdatePostedDate: Optional[datetime] = Field(
        None,
        description='Date when the last update of the [RESOURCE] was posted/published.',
        example='',
        title='Last update posted/published on',
    )
    lastUpdatePostedUser: Optional[LastUpdatePostedUser] = Field(
        None,
        description='User who posted/published the last update of the [RESOURCE].',
        example='',
        title='Last update posted/published by',
    )
    resourceVersion: Optional[str] = Field(
        None,
        description='Version number of the [RESOURCE] within this portal.',
        example='',
        title='Version number',
    )


class PrimaryDesign(Enum):
    Non_interventional = 'Non-interventional'
    Interventional = 'Interventional'


class InterventionalEnum(Enum):
    Single_group = 'Single group'
    Parallel = 'Parallel'
    Crossover = 'Crossover'
    Factorial = 'Factorial'
    Sequential = 'Sequential'
    Other = 'Other'
    Unknown = 'Unknown'


class NonInterventionalEnum(Enum):
    Case_control = 'Case-control'
    Nested_case_control = 'Nested case-control'
    Case_only = 'Case-only'
    Case_crossover = 'Case-crossover'
    Ecologic_or_community_studies = 'Ecologic or community studies'
    Family_based = 'Family-based'
    Twin_study = 'Twin study'
    Cohort = 'Cohort'
    Case_cohort = 'Case-cohort'
    Birth_cohort = 'Birth cohort'
    Trend = 'Trend'
    Panel = 'Panel'
    Longitudinal = 'Longitudinal'
    Cross_sectional = 'Cross-sectional'
    Cross_sectional_ad_hoc_follow_up = 'Cross-sectional ad-hoc follow-up'
    Time_series = 'Time series'
    Quality_control = 'Quality control'
    Register_studies = 'Register studies'
    Other = 'Other'
    Unknown = 'Unknown'


class StudyType(BaseModel):
    class Config:
        extra = Extra.forbid

    interventional: Optional[List[InterventionalEnum]] = Field(
        None,
        description='The strategy for assigning interventions to participants.',
        example='',
        min_items=1,
        title='Interventional [RESOURCE] type',
    )
    nonInterventional: Optional[List[NonInterventionalEnum]] = Field(
        None,
        description='The primary strategy for participant identification and follow-up.',
        example='',
        min_items=1,
        title='Non-interventional [RESOURCE] type',
    )


class Classification1(Enum):
    MeSH = 'MeSH'
    ICD_10 = 'ICD-10'
    ICD_11 = 'ICD-11'
    MedDRA = 'MedDRA'
    SNOMED_CT = 'SNOMED CT'
    Other_vocabulary = 'Other vocabulary'
    Free_text = 'Free text'


class Condition(BaseModel):
    class Config:
        extra = Extra.forbid

    label: constr(min_length=1) = Field(
        ...,
        description='Name of primary health condition or disease considered in the [RESOURCE].',
        example='SARS-CoV-2',
        title='Primary health condition or disease name',
    )
    classification: Classification1 = Field(
        ...,
        description='Terminology/classification used for the health condition or disease.',
        example='SNOMED CT',
        title='Terminology/classification',
    )
    code: Optional[AnyUrl] = Field(
        None,
        description='Code of the health condition or disease in the terminology/classification used.',
        example='http://snomed.info/id/840533007',
        title='Code of the health condition or disease',
    )


class Focu(BaseModel):
    class Config:
        extra = Extra.forbid

    label: constr(min_length=1) = Field(
        ...,
        description='Focus area of the [RESOURCE] (e.g. medication, food, therapy, device, etc.).',
        example='',
        title='Focus area',
    )
    classification: Classification1 = Field(
        ...,
        description='Terminology/classification used for the focus area.',
        example='SNOMED CT',
        title='Terminology/classification',
    )
    code: Optional[AnyUrl] = Field(
        None,
        description='Code of the focus area in the terminology/classification used.',
        example='http://snomed.info/id/840533007',
        title='Code of the focus area',
    )


class GenerallyEnum(Enum):
    Certain_infectious_or_parasitic_diseases__I_ = (
        'Certain infectious or parasitic diseases (I)'
    )
    Neoplasms__II_ = 'Neoplasms (II)'
    Diseases_of_the_blood_or_blood_forming_organs_and_certain_disorders_involving_the_immune_mechanism__III_ = 'Diseases of the blood or blood-forming organs and certain disorders involving the immune mechanism (III)'
    Endocrine__nutritional_and_metabolic_diseases__IV_ = (
        'Endocrine, nutritional and metabolic diseases (IV)'
    )
    Mental_and_behavioural_disorders__V_ = 'Mental and behavioural disorders (V)'
    Diseases_of_the_nervous_system__VI_ = 'Diseases of the nervous system (VI)'
    Diseases_of_the_eye_and_adnexa__VII_ = 'Diseases of the eye and adnexa (VII)'
    Diseases_of_the_ear_or_mastoid_process__VIII_ = (
        'Diseases of the ear or mastoid process (VIII)'
    )
    Diseases_of_the_circulatory_system__IX_ = 'Diseases of the circulatory system (IX)'
    Diseases_of_the_respiratory_system__X_ = 'Diseases of the respiratory system (X)'
    Diseases_of_the_digestive_system__XI_ = 'Diseases of the digestive system (XI)'
    Diseases_of_the_skin_and_subcutaneous_tissue__XII_ = (
        'Diseases of the skin and subcutaneous tissue (XII)'
    )
    Diseases_of_the_musculoskeletal_system_and_connective_tissue__XIII_ = (
        'Diseases of the musculoskeletal system and connective tissue (XIII)'
    )
    Diseases_of_the_genitourinary_system__XIV_ = (
        'Diseases of the genitourinary system (XIV)'
    )
    Pregnancy__childbirth_or_the_puerperium__XV_ = (
        'Pregnancy, childbirth or the puerperium (XV)'
    )
    Certain_conditions_originating_in_the_perinatal_period__XVI_ = (
        'Certain conditions originating in the perinatal period (XVI)'
    )
    Congenital_malformations__deformations_and_chromosomal_abnormalities__XVII_ = (
        'Congenital malformations, deformations and chromosomal abnormalities (XVII)'
    )
    Symptoms__signs_and_abnormal_clinical_and_laboratory_findings__not_elsewhere_classified__XVIII_ = 'Symptoms, signs and abnormal clinical and laboratory findings, not elsewhere classified (XVIII)'
    Injury__poisoning_and_certain_other_consequences_of_external_causes__XIX_ = (
        'Injury, poisoning and certain other consequences of external causes (XIX)'
    )
    External_causes_of_morbidity_or_mortality__XX_ = (
        'External causes of morbidity or mortality (XX)'
    )
    Factors_influencing_health_status_and_contact_with_health_services__XXI_ = (
        'Factors influencing health status and contact with health services (XXI)'
    )
    Other = 'Other'
    Not_applicable = 'Not applicable'
    Unknown = 'Unknown'


class Condition1(Enum):
    Cholera__1A00_ = 'Cholera (1A00)'
    Intestinal_infection_due_to_other_Vibrio__1A01_ = (
        'Intestinal infection due to other Vibrio (1A01)'
    )
    Intestinal_infections_due_to_Shigella__1A02_ = (
        'Intestinal infections due to Shigella (1A02)'
    )


class GroupsOfDiseases(BaseModel):
    class Config:
        extra = Extra.forbid

    generally: List[GenerallyEnum] = Field(
        ...,
        description='General groups of diseases or conditions on which the data were collected in the [RESOURCE].',
        example='',
        min_items=1,
        title='Which groups of diseases or conditions were the data collected on?',
    )
    conditions: Optional[List[Condition1]] = Field(
        None,
        description='Diseases or conditions on which the data were collected in the [RESOURCE].',
        example='',
        min_items=0,
        title='On which diseases or conditions were the data collected?',
    )


class MortalityData(Enum):
    Yes__vital_status_only__cause_of_death_missing_ = (
        'Yes, vital status only (cause of death missing)'
    )
    Yes__with_cause_of_death = 'Yes, with cause of death'
    No = 'No'


class EthicsCommitteeApproval(Enum):
    Request_for_approval_not_yet_submitted = 'Request for approval not yet submitted'
    Request_for_approval_submitted__approval_pending = (
        'Request for approval submitted, approval pending'
    )
    Request_for_approval_submitted__approval_granted = (
        'Request for approval submitted, approval granted'
    )
    Request_for_approval_submitted__exempt_granted = (
        'Request for approval submitted, exempt granted'
    )
    Request_for_approval_submitted__approval_denied = (
        'Request for approval submitted, approval denied'
    )
    Approval_not_required = 'Approval not required'
    Study_withdrawn_prior_to_decision_on_approval = (
        'Study withdrawn prior to decision on approval'
    )
    Unknown_status_of_request_approval = 'Unknown status of request approval'


class Status(Enum):
    At_the_planning_stage = 'At the planning stage'
    Ongoing__I___Recruitment_ongoing__but_data_collection_not_yet_started = (
        'Ongoing (I): Recruitment ongoing, but data collection not yet started'
    )
    Ongoing__II___Recruitment_and_data_collection_ongoing = (
        'Ongoing (II): Recruitment and data collection ongoing'
    )
    Ongoing__III___Recruitment_completed__but_data_collection_ongoing = (
        'Ongoing (III): Recruitment completed, but data collection ongoing'
    )
    Ongoing__IV___Recruitment_and_data_collection_completed__but_data_quality_management_ongoing = 'Ongoing (IV): Recruitment and data collection completed, but data quality management ongoing'
    Suspended__Recruitment__data_collection__or_data_quality_management__halted__but_potentially_will_resume = 'Suspended: Recruitment, data collection, or data quality management, halted, but potentially will resume'
    Terminated__Recruitment__data_collection__data_and_quality_management_halted_prematurely_and_will_not_resume = 'Terminated: Recruitment, data collection, data and quality management halted prematurely and will not resume'
    Completed__Recruitment__data_collection__and_data_quality_management_completed_normally = 'Completed: Recruitment, data collection, and data quality management completed normally'
    Other = 'Other'


class StatusWhenIntervention(Enum):
    Intervention_ongoing = 'Intervention ongoing'
    Intervention_completed__follow_up_ongoing = (
        'Intervention completed, follow-up ongoing'
    )


class StageStopped(Enum):
    At_the_planning_stage = 'At the planning stage'
    Ongoing__I___Recruitment_ongoing__but_data_collection_not_yet_started = (
        'Ongoing (I): Recruitment ongoing, but data collection not yet started'
    )
    Ongoing__II___Recruitment_and_data_collection_ongoing = (
        'Ongoing (II): Recruitment and data collection ongoing'
    )
    Ongoing__III___Recruitment_completed__but_data_collection_ongoing = (
        'Ongoing (III): Recruitment completed, but data collection ongoing'
    )
    Ongoing__IV___Recruitment_and_data_collection_completed__but_data_quality_management_ongoing = 'Ongoing (IV): Recruitment and data collection completed, but data quality management ongoing'


class StatusEnrollingByInvitation(Enum):
    Yes = 'Yes'
    No = 'No'
    Not_applicable = 'Not applicable'


class RecruitmentStatusRegister(Enum):
    Not_yet_recruiting = 'Not yet recruiting'
    Recruiting = 'Recruiting'
    Enrolling_by_invitation = 'Enrolling by invitation'
    Active__not_recruiting = 'Active, not recruiting'
    Completed = 'Completed'
    Suspended = 'Suspended'
    Terminated = 'Terminated'
    Withdrawn = 'Withdrawn'
    Other = 'Other'


class AdministrativeInformation(BaseModel):
    class Config:
        extra = Extra.forbid

    ethicsCommitteeApproval: Optional[EthicsCommitteeApproval] = Field(
        None,
        description='Status of the [RESOURCE] approval from the (leading) ethics committee.',
        example='',
        title='Status of the ethics committee approval',
    )
    status: Optional[Status] = Field(
        None,
        description='Overall status of the [RESOURCE].',
        example='',
        title='Overall [RESOURCE] status',
    )
    statusWhenIntervention: Optional[StatusWhenIntervention] = Field(
        None,
        description='Specification whether [RESOURCE] participants receive an intervention or have completed it but are still being followed up according to the primary objective of the [RESOURCE].',
        example='',
        title='Participants receive an intervention?',
    )
    stageStopped: Optional[StageStopped] = Field(
        None,
        description='Specification of the stage at which the [RESOURCE] was prematurely stopped.',
        example='',
        title='Stopping stage',
    )
    reasonStopped: Optional[str] = Field(
        None,
        description='Specification of the reason(s) why the [RESOURCE] was prematurely stopped.',
        example='accrual goal met',
        title='Stopping reason',
    )
    statusEnrollingByInvitation: Optional[StatusEnrollingByInvitation] = Field(
        None,
        description='Specification whether [RESOURCE] participants are selected from a predetermined population.',
        example='',
        title='Participants enrolled by invitation?',
    )
    recruitmentStatusRegister: Optional[RecruitmentStatusRegister] = Field(
        None,
        description='Overall recruitment status of the [RESOURCE] as indicated in the corresponding register of clinical trials.',
        example='',
        title='Overall recruitment status from the register of clinical trials',
    )
    startDate: Optional[datetime] = Field(
        None,
        description='Start date of data collection for the [RESOURCE].',
        example='',
        title='Start date',
    )
    endDate: Optional[datetime] = Field(
        None,
        description='In case of a [RESOURCE] with patients or other participants, it is the date when the last participant is examined or receives an intervention, or the date of the last participant’s last visit.',
        example='',
        title='End date',
    )


class Centers(Enum):
    Monocentric = 'Monocentric'
    Multicentric = 'Multicentric'


class DataProviders(Enum):
    One_data_provider = 'One data provider'
    Several_data_providers = 'Several data providers'


class Subject(Enum):
    Person = 'Person'
    Animal = 'Animal'
    Other = 'Other'
    Unknown = 'Unknown'


class Method(Enum):
    Probability = 'Probability'
    Non_probability = 'Non-probability'
    Mixed_probability_and_non_probability = 'Mixed probability and non-probability'
    Total_universe_Complete_enumeration = 'Total universe/Complete enumeration'
    Other = 'Other'
    Unknown = 'Unknown'
    Not_applicable = 'Not applicable'


class ProbabilityMethod(Enum):
    Simple_random = 'Simple random'
    Systematic_random = 'Systematic random'
    Stratified = 'Stratified'
    Stratified__Proportional = 'Stratified: Proportional'
    Stratified__Disproportional = 'Stratified: Disproportional'
    Cluster = 'Cluster'
    Cluster__Simple_random = 'Cluster: Simple random'
    Cluster__Stratified_random = 'Cluster: Stratified random'
    Multistage = 'Multistage'


class NonProbabilityMethod(Enum):
    Availability = 'Availability'
    Purposive = 'Purposive'
    Quota = 'Quota'
    Respondent_assisted = 'Respondent-assisted'


class Sampling(BaseModel):
    class Config:
        extra = Extra.forbid

    method: Method = Field(
        ...,
        description='Type of the sampling method applied for the selection of [RESOURCE] participants.',
        example='',
        title='Applied sampling method',
    )
    probabilityMethod: Optional[ProbabilityMethod] = Field(
        None,
        description='Specific type of the probability sampling method applied for the selection of [RESOURCE] participants.',
        example='',
        title='Specific type of probability sampling',
    )
    nonProbabilityMethod: Optional[NonProbabilityMethod] = Field(
        None,
        description='Specific type of the non-probability sampling method applied for the selection of [RESOURCE] participants.',
        example='',
        title='Specific type of non-probability sampling',
    )


class GeneralEnum(Enum):
    Administrative_databases = 'Administrative databases'
    Biological_samples = 'Biological samples'
    Cognitive_measurements = 'Cognitive measurements'
    Genealogical_records = 'Genealogical records'
    Imaging_data = 'Imaging data'
    Interview = 'Interview'
    Medical_records = 'Medical records'
    Omics_technology = 'Omics technology'
    Physiological_Biochemical_measurements = 'Physiological/Biochemical measurements'
    Questionnaire = 'Questionnaire'
    Registries = 'Registries'
    Other = 'Other'


class Biosample(Enum):
    Blood = 'Blood'
    Buccal_cells = 'Buccal cells'
    Cord_blood = 'Cord blood'
    DNA = 'DNA'
    Faeces = 'Faeces'
    Hair = 'Hair'
    Immortalized_cell_lines = 'Immortalized cell lines'
    Isolated_pathogen = 'Isolated pathogen'
    Nail = 'Nail'
    Plasma = 'Plasma'
    RNA = 'RNA'
    Saliva = 'Saliva'
    Serum = 'Serum'
    Tissue__FFPE_ = 'Tissue (FFPE)'
    Tissue__frozen_ = 'Tissue (frozen)'
    Urine = 'Urine'
    Other_biological_samples = 'Other biological samples'


class ImagingEnum(Enum):
    Computed_tomography__CT_ = 'Computed tomography (CT)'
    Magnetic_resonance_imaging__MRI_ = 'Magnetic resonance imaging (MRI)'
    Radiography__x_ray_ = 'Radiography (x-ray)'
    Ultrasound = 'Ultrasound'
    Other_imaging_data = 'Other imaging data'


class Omic(Enum):
    Biomarkers = 'Biomarkers'
    Genomics = 'Genomics'
    Metabolomics = 'Metabolomics'
    Proteomics = 'Proteomics'
    Transcriptomics = 'Transcriptomics'
    Other_omics_technology = 'Other omics technology'


class DataSource1(BaseModel):
    class Config:
        extra = Extra.forbid

    general: Optional[List[GeneralEnum]] = Field(
        None,
        description='Different types of data sources from which the data of the [RESOURCE] are generated or extracted.',
        example='',
        min_items=0,
        title='Type(s) of data sources',
    )
    biosamples: Optional[List[Biosample]] = Field(
        None,
        description='Specification of biosamples collected in the [RESOURCE].',
        example='',
        min_items=0,
        title='Biosamples collected',
    )
    imaging: Optional[List[ImagingEnum]] = Field(
        None,
        description='Specification of imaging data collected in the [RESOURCE].',
        example='',
        min_items=0,
        title='Imaging data collected',
    )
    omics: Optional[List[Omic]] = Field(
        None,
        description='Specification of omics technology applied in the [RESOURCE].',
        example='',
        min_items=0,
        title='Omics technology used',
    )
    description: Optional[str] = Field(
        None,
        description="If needed, additional descriptive information about the data sources of the [RESOURCE], e.g. indication of the data source(s) not listed in the field 'Type(s) of data sources' or a more detailed description of the selected data sources.",
        example='',
        title='Additional information about data sources',
    )


class PrimaryPurpose(Enum):
    Treatment = 'Treatment'
    Prevention = 'Prevention'
    Prognostic = 'Prognostic'
    Diagnostic = 'Diagnostic'
    Supportive_care = 'Supportive care'
    Screening = 'Screening'
    Health_services_research = 'Health services research'
    Basic_science_Physiological_study = 'Basic science/Physiological study'
    Device_feasibility = 'Device feasibility'
    Pharmacogenetics = 'Pharmacogenetics'
    Pharmacogenomics = 'Pharmacogenomics'
    Health_economics = 'Health economics'
    Not_applicable = 'Not applicable'
    Other = 'Other'


class TimeUnit(Enum):
    Years = 'Years'
    Months = 'Months'
    Weeks = 'Weeks'
    Days = 'Days'
    Hours = 'Hours'
    Minutes = 'Minutes'
    Weeks_of_gestation = 'Weeks of gestation'


class AgeMin(BaseModel):
    class Config:
        extra = Extra.forbid

    number: int = Field(
        ...,
        description='Numerical value of the minimum age of potential participants eligible to participate in the [RESOURCE].',
        example='',
        title='Minimum eligible age',
    )
    timeUnit: TimeUnit = Field(
        ...,
        description='Unit of measurement used to describe the minimum eligible age.',
        example='',
        title='Unit of age',
    )


class AgeMax(BaseModel):
    class Config:
        extra = Extra.forbid

    number: int = Field(
        ...,
        description='Numerical value of the maximum age of potential participants eligible to participate in the [RESOURCE].',
        example='',
        title='Maximum eligible age',
    )
    timeUnit: TimeUnit = Field(
        ...,
        description='Unit of measurement used to describe the maximum eligible age.',
        example='',
        title='Unit of age',
    )


class Gender(Enum):
    Male = 'Male'
    Female = 'Female'
    Diverse = 'Diverse'
    Not_applicable = 'Not applicable'


class EligibilityCriteria(BaseModel):
    class Config:
        extra = Extra.forbid

    ageMin: Optional[AgeMin] = Field(
        None,
        description='Group of items providing information about the minimum eligible age of [RESOURCE] participants.',
        example='',
        title='Eligibility criteria: Minimum age',
    )
    ageMax: Optional[AgeMax] = Field(
        None,
        description='Group of items providing information about the maximum eligible age of [RESOURCE] participants.',
        example='',
        title='Eligibility criteria: Maximum age',
    )
    genders: Optional[List[Gender]] = Field(
        None,
        description='Gender of potential participants eligible to participate in the [RESOURCE].',
        example='',
        min_items=0,
        title='Eligible gender',
    )
    inclusionCriteria: Optional[str] = Field(
        None,
        description='Inclusion criteria for participation in the [RESOURCE].',
        example='- First inclusion criterion; - Second inclusion criterion;',
        title='Inclusion criteria',
    )
    exclusionCriteria: Optional[str] = Field(
        None,
        description='Exclusion criteria for participation in the [RESOURCE].',
        example='- First inclusion criterion; - Second inclusion criterion;',
        title='Exclusion criteria',
    )


class Coverage(Enum):
    International = 'International'
    National = 'National'
    Regional = 'Regional'


class Type3(Enum):
    Experimental = 'Experimental'
    Active_comparator = 'Active comparator'
    Placebo_comparator = 'Placebo comparator'
    Sham_comparator = 'Sham comparator'
    No_intervention = 'No intervention'
    Other = 'Other'


class Arm(BaseModel):
    class Config:
        extra = Extra.forbid

    label: constr(min_length=1) = Field(
        ...,
        description='Short name used to identify the arm.',
        example='',
        title='Name of the arm',
    )
    type: Type3 = Field(
        ...,
        description='Role of the given arm in the [RESOURCE].',
        example='',
        title='Role of the arm',
    )
    description: Optional[str] = Field(
        None,
        description='Additional descriptive information about the given arm.',
        example='',
        title='Additional information about the arm',
    )


class Group(BaseModel):
    class Config:
        extra = Extra.forbid

    label: constr(min_length=1) = Field(
        ...,
        description='Short name used to identify the group.',
        example='',
        title='Name of the group',
    )
    description: Optional[str] = Field(
        None,
        description='Additional descriptive information about the given group.',
        example='',
        title='Additional information about the group',
    )


class Type4(Enum):
    Drug__including_placebo_ = 'Drug (including placebo)'
    Device__including_sham_ = 'Device (including sham)'
    Biological_Vaccine = 'Biological/Vaccine'
    Procedure_Surgery = 'Procedure/Surgery'
    Radiation = 'Radiation'
    Behavioral__e_g___psychotherapy__lifestyle_counseling_ = (
        'Behavioral (e.g., psychotherapy, lifestyle counseling)'
    )
    Genetic__including_gene_transfer__stem_cell_and_recombinant_DNA_ = (
        'Genetic (including gene transfer, stem cell and recombinant DNA)'
    )
    Dietary_supplement__e_g___vitamins__minerals_ = (
        'Dietary supplement (e.g., vitamins, minerals)'
    )
    Combination_product__combining_a_drug_and_device__a_biological_product_and_device__a_drug_and_biological_product__or_a_drug__biological_product__and_device_ = 'Combination product (combining a drug and device, a biological product and device; a drug and biological product; or a drug, biological product, and device)'
    Diagnostic_test__e_g___imaging__in_vitro_ = (
        'Diagnostic test (e.g., imaging, in-vitro)'
    )
    Other = 'Other'


class Intervention(BaseModel):
    class Config:
        extra = Extra.forbid

    name: constr(min_length=1) = Field(
        ...,
        description='A short descriptive name of the intervention.',
        example='',
        title='Name of the intervention',
    )
    type: Optional[Type4] = Field(
        None,
        description='General type of the given intervention.',
        example='',
        title='Type of the intervention',
    )
    description: Optional[str] = Field(
        None,
        description='If needed, additional descriptive information about the given intervention.',
        example='',
        title='Additional information about the intervention',
    )
    armsLabel: Optional[str] = Field(
        None,
        description='Name(s) of the [RESOURCE] arm(s) associated with the given intervention.',
        example='',
        title='Name(s) of the arm(s) associated with the given intervention',
    )


class Exposure(BaseModel):
    class Config:
        extra = Extra.forbid

    name: Optional[str] = Field(
        None,
        description='A short descriptive name of the exposure.',
        example='',
        title='Name of the exposure',
    )
    type: Optional[Type4] = Field(
        None,
        description='General type of the given exposure.',
        example='',
        title='Type of the exposure',
    )
    description: Optional[str] = Field(
        None,
        description='If needed, additional descriptive information about the given exposure.',
        example='',
        title='Additional information about the exposure',
    )
    groupsLabel: Optional[str] = Field(
        None,
        description='Name(s) of the [RESOURCE] group(s) associated with the given exposure.',
        example='',
        title='Name(s) of the group(s) associated with the given exposure',
    )


class Type6(Enum):
    Primary = 'Primary'
    Secondary = 'Secondary'
    Other = 'Other'


class Outcome(BaseModel):
    class Config:
        extra = Extra.forbid

    title: constr(min_length=1) = Field(
        ...,
        description='Name of the outcome measure. For non-interventional studies, this can be the name of specific measurement(s) or observation(s) used to describe patterns of diseases or traits or associations with exposures, risk factors or treatment.',
        example='',
        title='Name of the outcome measure',
    )
    description: Optional[str] = Field(
        None,
        description='Additional descriptive information about the given outcome.',
        example='',
        title='Description of the outcome measure',
    )
    type: Optional[Type6] = Field(
        None,
        description='The type indicates the degree of importance of the outcome measure in the [RESOURCE].',
        example='',
        title='Type of the outcome measure',
    )
    timeFrame: Optional[str] = Field(
        None,
        description='Description of the time point(s) at which the measurement for the outcome is assessed, e.g. the specific duration of time over which each participant is assessed.',
        example='',
        title='Time point(s) of assessment',
    )


class Assessment(Enum):
    Diet_Nutrition = 'Diet/Nutrition'
    Physical_activity = 'Physical activity'
    Tobacco_use = 'Tobacco use'
    Alcohol_consumption = 'Alcohol consumption'
    Body_weight = 'Body weight'
    Body_height = 'Body height'
    Waist_circumference = 'Waist circumference'
    Body_Mass_Index = 'Body Mass Index'
    Body_fat_percentage = 'Body fat percentage'
    Sociodemographic_information = 'Sociodemographic information'


class Generally(Enum):
    Yes__there_is_a_plan_to_make_data_available = (
        'Yes, there is a plan to make data available'
    )
    No__there_is_no_plan_to_make_data_available = (
        'No, there is no plan to make data available'
    )
    Undecided__it_is_not_yet_known_if_data_will_be_made_available = (
        'Undecided, it is not yet known if data will be made available'
    )


class SupportingInformation(Enum):
    Data_dictionary = 'Data dictionary'
    Study_protocol = 'Study protocol'
    Protocol_amendment = 'Protocol amendment'
    Statistical_analysis_plan = 'Statistical analysis plan'
    Analytic_code = 'Analytic code'
    Informed_consent_form = 'Informed consent form'
    Clinical_study_report = 'Clinical study report'
    Manual_of_operations__SOP_ = 'Manual of operations (SOP)'
    Case_report_form__template_ = 'Case report form (template)'
    Questionnaire__template_ = 'Questionnaire (template)'
    Code_book = 'Code book'
    Other = 'Other'


class Datashield(Enum):
    Yes = 'Yes'
    No = 'No'
    Pending = 'Pending'


class DataSharingPlan(BaseModel):
    class Config:
        extra = Extra.forbid

    generally: Generally = Field(
        ...,
        description='Indication whether there is a plan to make data collected in the [RESOURCE] available. In case of a [RESOURCE] with patients or other individuals, this refers to individual participant data (IPD).',
        example='',
        title='Is it planned to share the data?',
    )
    supportingInformation: Optional[List[SupportingInformation]] = Field(
        None,
        description='Supporting information/documents which will be made available in addition to the data collected in the [RESOURCE].',
        example='',
        min_items=0,
        title='Supporting documents available in addition to the data',
    )
    timeFrame: Optional[str] = Field(
        None,
        description='Indication of the time period for which the data and, if applicable, supporting documents will be made available.',
        example='',
        title='When and for how long will the data be available?',
    )
    accessCriteria: Optional[str] = Field(
        None,
        description='Indication of the access criteria by which the data will be shared, including: a) with whom; b) for which types of analyses; and c) by what mechanism.',
        example='',
        title='Criteria for data access',
    )
    description: Optional[str] = Field(
        None,
        description='Additional descriptive information providing more details about data sharing, e.g. indication of which data in particular will be shared or why the data will not be shared or why it is not yet decided.',
        example='',
        title='Additional information about data sharing',
    )
    datashield: Optional[Datashield] = Field(
        None,
        description='Indication whether the DataSHIELD/Opal infrastructure is available.',
        example='',
        title='DataSHIELD/Opal infrastructure available?',
    )
    requestData: Optional[AnyUrl] = Field(
        None,
        description='If existing, a link to the web page where the data request form and/or information on data reuse can be found.',
        example='',
        title='Link to data request application',
    )
    url: Optional[AnyUrl] = Field(
        None,
        description='If existing, a link to the web page where additional information about data sharing can be found.',
        example='',
        title='Web page with additional information about data sharing',
    )
    recordLinkage: Optional[bool] = Field(
        None,
        description='Indication if record linkage with other data sources is possible.',
        example='',
        title='Record linkage possible?',
    )


class TimePerspective(Enum):
    Retrospective = 'Retrospective'
    Prospective = 'Prospective'
    Cross_sectional = 'Cross-sectional'
    Other = 'Other'


class TimeUnit2(Enum):
    Years = 'Years'
    Months = 'Months'
    Weeks = 'Weeks'
    Days = 'Days'


class TargetFollowUpDuration(BaseModel):
    class Config:
        extra = Extra.forbid

    number: int = Field(
        ...,
        description='Numerical value of the target follow-up duration.',
        example='',
        title='Target follow-up duration',
    )
    timeUnit: TimeUnit2 = Field(
        ...,
        description='Unit of measurement used to describe the follow-up duration.',
        example='',
        title='Unit of time',
    )
    frequency: Optional[int] = Field(
        None,
        description='The number of follow-ups conducted within the specified duration.',
        example='',
        title='Number of follow-ups conducted',
    )


class BiospecimenRetentionEnum(Enum):
    None_retained = 'None retained'
    Samples_with_DNA = 'Samples with DNA'
    Samples_without_DNA = 'Samples without DNA'


class NonInterventional(BaseModel):
    class Config:
        extra = Extra.forbid

    timePerspectives: Optional[List[TimePerspective]] = Field(
        None,
        description='Temporal design of the [RESOURCE], i.e. the observation period in relation to the time of participant enrollment.',
        example='',
        min_items=0,
        title='Temporal design',
    )
    targetFollowUpDuration: Optional[TargetFollowUpDuration] = Field(
        None,
        description='If applicable, anticipated time period over which each participant would be followed.',
        example='',
        title='Target follow-up duration of the [RESOURCE]',
    )
    biospecimenRetention: Optional[List[BiospecimenRetentionEnum]] = Field(
        None,
        description='Indication whether samples of biomaterials from participants of the [RESOURCE] are retained in a biorepository.',
        example='',
        min_items=0,
        title='Biosamples retained in a biorepository',
    )
    biospecimenDescription: Optional[str] = Field(
        None,
        description='Additional information about retained biosamples, i.e. an indication of the specific types of retained biospecimens (e.g. blood, serum, urine, etc.).',
        example='blood',
        title='Specific types of retained biosamples',
    )


class Phase(Enum):
    Early_phase_1 = 'Early-phase-1'
    Phase_1 = 'Phase-1'
    Phase_1_phase_2 = 'Phase-1-phase-2'
    Phase_2 = 'Phase-2'
    Phase_2a = 'Phase-2a'
    Phase_2b = 'Phase-2b'
    Phase_2_phase_3 = 'Phase-2-phase-3'
    Phase_3 = 'Phase-3'
    Phase_3a = 'Phase-3a'
    Phase_3b = 'Phase-3b'
    Phase_4 = 'Phase-4'
    Other = 'Other'
    Not_applicable = 'Not applicable'


class Role(Enum):
    Participant = 'Participant'
    Care_provider = 'Care provider'
    Investigator = 'Investigator'
    Outcomes_assessor = 'Outcomes assessor'


class Masking(BaseModel):
    class Config:
        extra = Extra.forbid

    general: Optional[bool] = Field(
        None,
        description='Indication whether a masking (or blinding) of intervention(s) assignment is implemented (i.e., whether someone is prevented from having knowledge of the interventions assigned to individual participants).',
        example='',
        title='Masking implemented?',
    )
    roles: Optional[List[Role]] = Field(
        None,
        description='If masking is implemented, the party(ies) who are masked.',
        example='',
        min_items=0,
        title='Who is masked?',
    )
    description: Optional[str] = Field(
        None,
        description='If needed, additional descriptive information about masking (e.g. information about other parties who may be masked).',
        example='',
        title='Additional information about masking',
    )


class Allocation(Enum):
    Randomized = 'Randomized'
    Nonrandomized = 'Nonrandomized'
    Not_applicable__for_single_arm_trials_ = 'Not applicable (for single-arm trials)'


class OffLabelUse(Enum):
    Yes = 'Yes'
    No = 'No'
    Not_applicable = 'Not applicable'


class Interventional(BaseModel):
    class Config:
        extra = Extra.forbid

    phase: Optional[Phase] = Field(
        None,
        description='If applicable, numerical phase of the [RESOURCE].',
        example='',
        title='Numerical phase',
    )
    masking: Optional[Masking] = Field(
        None,
        description='Group of items providing information about the masking of intervention(s) assignment.',
        example='',
        title='Masking of intervention(s) assignment',
    )
    allocation: Optional[Allocation] = Field(
        None,
        description='Type of allocation/assignment of individual participants of the [RESOURCE] to an arm.',
        example='',
        title='Type of allocation of participants to an arm',
    )
    offLabelUse: Optional[OffLabelUse] = Field(
        None,
        description='Unapproved (off-label) use of a drug product.',
        example='',
        title='Off-label use of a drug product',
    )


class CountryNamesFromTheISO31661List(Enum):
    Andorra = 'Andorra'
    United_Arab_Emirates = 'United Arab Emirates'
    Afghanistan = 'Afghanistan'
    Antigua_and_Barbuda = 'Antigua and Barbuda'
    Anguilla = 'Anguilla'
    Albania = 'Albania'
    Armenia = 'Armenia'
    Angola = 'Angola'
    Antarctica = 'Antarctica'
    Argentina = 'Argentina'
    American_Samoa = 'American Samoa'
    Austria = 'Austria'
    Australia = 'Australia'
    Aruba = 'Aruba'
    Åland_Islands = 'Åland Islands'
    Azerbaijan = 'Azerbaijan'
    Bosnia_and_Herzegovina = 'Bosnia and Herzegovina'
    Barbados = 'Barbados'
    Bangladesh = 'Bangladesh'
    Belgium = 'Belgium'
    Burkina_Faso = 'Burkina Faso'
    Bulgaria = 'Bulgaria'
    Bahrain = 'Bahrain'
    Burundi = 'Burundi'
    Benin = 'Benin'
    Saint_Barthélemy = 'Saint Barthélemy'
    Bermuda = 'Bermuda'
    Brunei_Darussalam = 'Brunei Darussalam'
    Bolivia__Plurinational_State_of = 'Bolivia, Plurinational State of'
    Bonaire__Sint_Eustatius_and_Saba = 'Bonaire, Sint Eustatius and Saba'
    Brazil = 'Brazil'
    Bahamas = 'Bahamas'
    Bhutan = 'Bhutan'
    Bouvet_Island = 'Bouvet Island'
    Botswana = 'Botswana'
    Belarus = 'Belarus'
    Belize = 'Belize'
    Canada = 'Canada'
    Cocos__Keeling__Islands = 'Cocos (Keeling) Islands'
    Congo__Democratic_Republic_of_the = 'Congo, Democratic Republic of the'
    Central_African_Republic = 'Central African Republic'
    Congo = 'Congo'
    Switzerland = 'Switzerland'
    Côte_d_Ivoire = 'Côte d\'Ivoire'
    Cook_Islands = 'Cook Islands'
    Chile = 'Chile'
    Cameroon = 'Cameroon'
    China = 'China'
    Colombia = 'Colombia'
    Costa_Rica = 'Costa Rica'
    Cuba = 'Cuba'
    Cabo_Verde = 'Cabo Verde'
    Curaçao = 'Curaçao'
    Christmas_Island = 'Christmas Island'
    Cyprus = 'Cyprus'
    Czechia = 'Czechia'
    Germany = 'Germany'
    Djibouti = 'Djibouti'
    Denmark = 'Denmark'
    Dominica = 'Dominica'
    Dominican_Republic = 'Dominican Republic'
    Algeria = 'Algeria'
    Ecuador = 'Ecuador'
    Estonia = 'Estonia'
    Egypt = 'Egypt'
    Western_Sahara = 'Western Sahara'
    Eritrea = 'Eritrea'
    Spain = 'Spain'
    Ethiopia = 'Ethiopia'
    Finland = 'Finland'
    Fiji = 'Fiji'
    Falkland_Islands__Malvinas_ = 'Falkland Islands (Malvinas)'
    Micronesia__Federated_States_of = 'Micronesia, Federated States of'
    Faroe_Islands = 'Faroe Islands'
    France = 'France'
    Gabon = 'Gabon'
    United_Kingdom_of_Great_Britain_and_Northern_Ireland = (
        'United Kingdom of Great Britain and Northern Ireland'
    )
    Grenada = 'Grenada'
    Georgia = 'Georgia'
    French_Guiana = 'French Guiana'
    Guernsey = 'Guernsey'
    Ghana = 'Ghana'
    Gibraltar = 'Gibraltar'
    Greenland = 'Greenland'
    Gambia = 'Gambia'
    Guinea = 'Guinea'
    Guadeloupe = 'Guadeloupe'
    Equatorial_Guinea = 'Equatorial Guinea'
    Greece = 'Greece'
    South_Georgia_and_the_South_Sandwich_Islands = (
        'South Georgia and the South Sandwich Islands'
    )
    Guatemala = 'Guatemala'
    Guam = 'Guam'
    Guinea_Bissau = 'Guinea-Bissau'
    Guyana = 'Guyana'
    Hong_Kong = 'Hong Kong'
    Heard_Island_and_McDonald_Islands = 'Heard Island and McDonald Islands'
    Honduras = 'Honduras'
    Croatia = 'Croatia'
    Haiti = 'Haiti'
    Hungary = 'Hungary'
    Indonesia = 'Indonesia'
    Ireland = 'Ireland'
    Israel = 'Israel'
    Isle_of_Man = 'Isle of Man'
    India = 'India'
    British_Indian_Ocean_Territory = 'British Indian Ocean Territory'
    Iraq = 'Iraq'
    Iran__Islamic_Republic_of = 'Iran, Islamic Republic of'
    Iceland = 'Iceland'
    Italy = 'Italy'
    Jersey = 'Jersey'
    Jamaica = 'Jamaica'
    Jordan = 'Jordan'
    Japan = 'Japan'
    Kenya = 'Kenya'
    Kyrgyzstan = 'Kyrgyzstan'
    Cambodia = 'Cambodia'
    Kiribati = 'Kiribati'
    Comoros = 'Comoros'
    Saint_Kitts_and_Nevis = 'Saint Kitts and Nevis'
    Korea__Democratic_People_s_Republic_of = 'Korea, Democratic People\'s Republic of'
    Korea__Republic_of = 'Korea, Republic of'
    Kuwait = 'Kuwait'
    Cayman_Islands = 'Cayman Islands'
    Kazakhstan = 'Kazakhstan'
    Lao_People_s_Democratic_Republic = 'Lao People\'s Democratic Republic'
    Lebanon = 'Lebanon'
    Saint_Lucia = 'Saint Lucia'
    Liechtenstein = 'Liechtenstein'
    Sri_Lanka = 'Sri Lanka'
    Liberia = 'Liberia'
    Lesotho = 'Lesotho'
    Lithuania = 'Lithuania'
    Luxembourg = 'Luxembourg'
    Latvia = 'Latvia'
    Libya = 'Libya'
    Morocco = 'Morocco'
    Monaco = 'Monaco'
    Moldova__Republic_of = 'Moldova, Republic of'
    Montenegro = 'Montenegro'
    Saint_Martin___French_part_ = 'Saint Martin, (French part)'
    Madagascar = 'Madagascar'
    Marshall_Islands = 'Marshall Islands'
    North_Macedonia = 'North Macedonia'
    Mali = 'Mali'
    Myanmar = 'Myanmar'
    Mongolia = 'Mongolia'
    Macao = 'Macao'
    Northern_Mariana_Islands = 'Northern Mariana Islands'
    Martinique = 'Martinique'
    Mauritania = 'Mauritania'
    Montserrat = 'Montserrat'
    Malta = 'Malta'
    Mauritius = 'Mauritius'
    Maldives = 'Maldives'
    Malawi = 'Malawi'
    Mexico = 'Mexico'
    Malaysia = 'Malaysia'
    Mozambique = 'Mozambique'
    Namibia = 'Namibia'
    New_Caledonia = 'New Caledonia'
    Niger = 'Niger'
    Norfolk_Island = 'Norfolk Island'
    Nigeria = 'Nigeria'
    Nicaragua = 'Nicaragua'
    Netherlands = 'Netherlands'
    Norway = 'Norway'
    Nepal = 'Nepal'
    Nauru = 'Nauru'
    Niue = 'Niue'
    New_Zealand = 'New Zealand'
    Oman = 'Oman'
    Panama = 'Panama'
    Peru = 'Peru'
    French_Polynesia = 'French Polynesia'
    Papua_New_Guinea = 'Papua New Guinea'
    Philippines = 'Philippines'
    Pakistan = 'Pakistan'
    Poland = 'Poland'
    Saint_Pierre_and_Miquelon = 'Saint Pierre and Miquelon'
    Pitcairn = 'Pitcairn'
    Puerto_Rico = 'Puerto Rico'
    Palestine__State_of = 'Palestine, State of'
    Portugal = 'Portugal'
    Palau = 'Palau'
    Paraguay = 'Paraguay'
    Qatar = 'Qatar'
    Réunion = 'Réunion'
    Romania = 'Romania'
    Serbia = 'Serbia'
    Russian_Federation = 'Russian Federation'
    Rwanda = 'Rwanda'
    Saudi_Arabia = 'Saudi Arabia'
    Solomon_Islands = 'Solomon Islands'
    Seychelles = 'Seychelles'
    Sudan = 'Sudan'
    Sweden = 'Sweden'
    Singapore = 'Singapore'
    Saint_Helena__Ascension_and_Tristan_da_Cunha = (
        'Saint Helena, Ascension and Tristan da Cunha'
    )
    Slovenia = 'Slovenia'
    Svalbard_and_Jan_Mayen = 'Svalbard and Jan Mayen'
    Slovakia = 'Slovakia'
    Sierra_Leone = 'Sierra Leone'
    San_Marino = 'San Marino'
    Senegal = 'Senegal'
    Somalia = 'Somalia'
    Suriname = 'Suriname'
    South_Sudan = 'South Sudan'
    Sao_Tome_and_Principe = 'Sao Tome and Principe'
    El_Salvador = 'El Salvador'
    Sint_Maarten___Dutch_part_ = 'Sint Maarten, (Dutch part)'
    Syrian_Arab_Republic = 'Syrian Arab Republic'
    Eswatini = 'Eswatini'
    Turks_and_Caicos_Islands = 'Turks and Caicos Islands'
    Chad = 'Chad'
    French_Southern_Territories = 'French Southern Territories'
    Togo = 'Togo'
    Thailand = 'Thailand'
    Tajikistan = 'Tajikistan'
    Tokelau = 'Tokelau'
    Timor_Leste = 'Timor-Leste'
    Turkmenistan = 'Turkmenistan'
    Tunisia = 'Tunisia'
    Tonga = 'Tonga'
    Türkiye = 'Türkiye'
    Trinidad_and_Tobago = 'Trinidad and Tobago'
    Tuvalu = 'Tuvalu'
    Taiwan__Province_of_China = 'Taiwan, Province of China'
    Tanzania__United_Republic_of = 'Tanzania, United Republic of'
    Ukraine = 'Ukraine'
    Uganda = 'Uganda'
    United_States_Minor_Outlying_Islands = 'United States Minor Outlying Islands'
    United_States_of_America = 'United States of America'
    Uruguay = 'Uruguay'
    Uzbekistan = 'Uzbekistan'
    Holy_See = 'Holy See'
    Saint_Vincent_and_the_Grenadines = 'Saint Vincent and the Grenadines'
    Venezuela__Bolivarian_Republic_of = 'Venezuela, Bolivarian Republic of'
    Virgin_Islands__British = 'Virgin Islands, British'
    Virgin_Islands__U_S_ = 'Virgin Islands, U.S.'
    Viet_Nam = 'Viet Nam'
    Vanuatu = 'Vanuatu'
    Wallis_and_Futuna = 'Wallis and Futuna'
    Samoa = 'Samoa'
    Yemen = 'Yemen'
    Mayotte = 'Mayotte'
    South_Africa = 'South Africa'
    Zambia = 'Zambia'
    Zimbabwe = 'Zimbabwe'


class LanguageNamesFromTheISO6391List(Enum):
    AA__Afar_ = 'AA (Afar)'
    AB__Abkhaz_ = 'AB (Abkhaz)'
    AE__Avestan_ = 'AE (Avestan)'
    AF__Afrikaans_ = 'AF (Afrikaans)'
    AK__Akan_ = 'AK (Akan)'
    AM__Amharic_ = 'AM (Amharic)'
    AN__Aragonese_ = 'AN (Aragonese)'
    AR__Arabic_ = 'AR (Arabic)'
    AS__Assamese_ = 'AS (Assamese)'
    AV__Avaric_ = 'AV (Avaric)'
    AY__Aymara_ = 'AY (Aymara)'
    AZ__Azerbaijani_ = 'AZ (Azerbaijani)'
    BA__Bashkir_ = 'BA (Bashkir)'
    BE__Belarusian_ = 'BE (Belarusian)'
    BG__Bulgarian_ = 'BG (Bulgarian)'
    BI__Bislama_ = 'BI (Bislama)'
    BM__Bambara_ = 'BM (Bambara)'
    BN__Bengali_ = 'BN (Bengali)'
    BO__Tibetan_ = 'BO (Tibetan)'
    BR__Breton_ = 'BR (Breton)'
    BS__Bosnian_ = 'BS (Bosnian)'
    CA__Catalan_ = 'CA (Catalan)'
    CE__Chechen_ = 'CE (Chechen)'
    CH__Chamorro_ = 'CH (Chamorro)'
    CO__Corsican_ = 'CO (Corsican)'
    CR__Cree_ = 'CR (Cree)'
    CS__Czech_ = 'CS (Czech)'
    CU__Old_Church_Slavonic_ = 'CU (Old Church Slavonic)'
    CV__Chuvash_ = 'CV (Chuvash)'
    CY__Welsh_ = 'CY (Welsh)'
    DA__Danish_ = 'DA (Danish)'
    DE__German_ = 'DE (German)'
    DV__Divehi_ = 'DV (Divehi)'
    DZ__Dzongkha_ = 'DZ (Dzongkha)'
    EE__Ewe_ = 'EE (Ewe)'
    EL__Greek_ = 'EL (Greek)'
    EN__English_ = 'EN (English)'
    EO__Esperanto_ = 'EO (Esperanto)'
    ES__Spanish_ = 'ES (Spanish)'
    ET__Estonian_ = 'ET (Estonian)'
    EU__Basque_ = 'EU (Basque)'
    FA__Persian_ = 'FA (Persian)'
    FF__Fula_ = 'FF (Fula)'
    FI__Finnish_ = 'FI (Finnish)'
    FJ__Fijian_ = 'FJ (Fijian)'
    FO__Faroese_ = 'FO (Faroese)'
    FR__French_ = 'FR (French)'
    FY__Western_Frisian_ = 'FY (Western Frisian)'
    GA__Irish_ = 'GA (Irish)'
    GD__Scottish_Gaelic_ = 'GD (Scottish Gaelic)'
    GL__Galician_ = 'GL (Galician)'
    GN__Guaraní_ = 'GN (Guaraní)'
    GU__Gujarati_ = 'GU (Gujarati)'
    GV__Manx_ = 'GV (Manx)'
    HA__Hausa_ = 'HA (Hausa)'
    HE__Hebrew_ = 'HE (Hebrew)'
    HI__Hindi_ = 'HI (Hindi)'
    HO__Hiri_Motu_ = 'HO (Hiri Motu)'
    HR__Croatian_ = 'HR (Croatian)'
    HT__Haitian_ = 'HT (Haitian)'
    HU__Hungarian_ = 'HU (Hungarian)'
    HY__Armenian_ = 'HY (Armenian)'
    HZ__Herero_ = 'HZ (Herero)'
    IA__Interlingua_ = 'IA (Interlingua)'
    ID__Indonesian_ = 'ID (Indonesian)'
    IE__Interlingue_ = 'IE (Interlingue)'
    IG__Igbo_ = 'IG (Igbo)'
    II__Nuosu_ = 'II (Nuosu)'
    IK__Inupiaq_ = 'IK (Inupiaq)'
    IO__Ido_ = 'IO (Ido)'
    IS__Icelandic_ = 'IS (Icelandic)'
    IT__Italian_ = 'IT (Italian)'
    IU__Inuktitut_ = 'IU (Inuktitut)'
    JA__Japanese_ = 'JA (Japanese)'
    JV__Javanese_ = 'JV (Javanese)'
    KA__Georgian_ = 'KA (Georgian)'
    KG__Kongo_ = 'KG (Kongo)'
    KI__Kikuyu_ = 'KI (Kikuyu)'
    KJ__Kwanyama_ = 'KJ (Kwanyama)'
    KK__Kazakh_ = 'KK (Kazakh)'
    KL__Kalaallisut_ = 'KL (Kalaallisut)'
    KM__Khmer_ = 'KM (Khmer)'
    KN__Kannada_ = 'KN (Kannada)'
    KO__Korean_ = 'KO (Korean)'
    KR__Kanuri_ = 'KR (Kanuri)'
    KS__Kashmiri_ = 'KS (Kashmiri)'
    KU__Kurdish_ = 'KU (Kurdish)'
    KV__Komi_ = 'KV (Komi)'
    KW__Cornish_ = 'KW (Cornish)'
    KY__Kyrgyz_ = 'KY (Kyrgyz)'
    LA__Latin_ = 'LA (Latin)'
    LB__Luxembourgish_ = 'LB (Luxembourgish)'
    LG__Ganda_ = 'LG (Ganda)'
    LI__Limburgish_ = 'LI (Limburgish)'
    LN__Lingala_ = 'LN (Lingala)'
    LO__Lao_ = 'LO (Lao)'
    LT__Lithuanian_ = 'LT (Lithuanian)'
    LU__Luba_Katanga_ = 'LU (Luba-Katanga)'
    LV__Latvian_ = 'LV (Latvian)'
    MG__Malagasy_ = 'MG (Malagasy)'
    MH__Marshallese_ = 'MH (Marshallese)'
    MI__Māori_ = 'MI (Māori)'
    MK__Macedonian_ = 'MK (Macedonian)'
    ML__Malayalam_ = 'ML (Malayalam)'
    MN__Mongolian_ = 'MN (Mongolian)'
    MR__Marathi_ = 'MR (Marathi)'
    MS__Malay_ = 'MS (Malay)'
    MT__Maltese_ = 'MT (Maltese)'
    MY__Burmese_ = 'MY (Burmese)'
    NA__Nauru_ = 'NA (Nauru)'
    NB__Norwegian_Bokmål_ = 'NB (Norwegian Bokmål)'
    ND__Northern_Ndebele_ = 'ND (Northern Ndebele)'
    NE__Nepali_ = 'NE (Nepali)'
    NG__Ndonga_ = 'NG (Ndonga)'
    NL__Dutch_ = 'NL (Dutch)'
    NN__Norwegian_Nynorsk_ = 'NN (Norwegian Nynorsk)'
    NO__Norwegian_ = 'NO (Norwegian)'
    NR__Southern_Ndebele_ = 'NR (Southern Ndebele)'
    NV__Navajo_ = 'NV (Navajo)'
    NY__Chichewa_ = 'NY (Chichewa)'
    OC__Occitan_ = 'OC (Occitan)'
    OJ__Ojibwe_ = 'OJ (Ojibwe)'
    OM__Oromo_ = 'OM (Oromo)'
    OR__Oriya_ = 'OR (Oriya)'
    OS__Ossetian_ = 'OS (Ossetian)'
    PA__Panjabi_ = 'PA (Panjabi)'
    PI__Pāli_ = 'PI (Pāli)'
    PL__Polish_ = 'PL (Polish)'
    PS__Pashto_ = 'PS (Pashto)'
    PT__Portuguese_ = 'PT (Portuguese)'
    QU__Quechua_ = 'QU (Quechua)'
    RM__Romansh_ = 'RM (Romansh)'
    RN__Kirundi_ = 'RN (Kirundi)'
    RO__Romanian_ = 'RO (Romanian)'
    RU__Russian_ = 'RU (Russian)'
    RW__Kinyarwanda_ = 'RW (Kinyarwanda)'
    SA__Sanskrit_ = 'SA (Sanskrit)'
    SC__Sardinian_ = 'SC (Sardinian)'
    SD__Sindhi_ = 'SD (Sindhi)'
    SE__Northern_Sami_ = 'SE (Northern Sami)'
    SG__Sango_ = 'SG (Sango)'
    SI__Sinhala_ = 'SI (Sinhala)'
    SK__Slovak_ = 'SK (Slovak)'
    SL__Slovenian_ = 'SL (Slovenian)'
    SM__Samoan_ = 'SM (Samoan)'
    SN__Shona_ = 'SN (Shona)'
    SO__Somali_ = 'SO (Somali)'
    SQ__Albanian_ = 'SQ (Albanian)'
    SR__Serbian_ = 'SR (Serbian)'
    SS__Swati_ = 'SS (Swati)'
    ST__Southern_Sotho_ = 'ST (Southern Sotho)'
    SU__Sundanese_ = 'SU (Sundanese)'
    SV__Swedish_ = 'SV (Swedish)'
    SW__Swahili_ = 'SW (Swahili)'
    TA__Tamil_ = 'TA (Tamil)'
    TE__Telugu_ = 'TE (Telugu)'
    TG__Tajik_ = 'TG (Tajik)'
    TH__Thai_ = 'TH (Thai)'
    TI__Tigrinya_ = 'TI (Tigrinya)'
    TK__Turkmen_ = 'TK (Turkmen)'
    TL__Tagalog_ = 'TL (Tagalog)'
    TN__Tswana_ = 'TN (Tswana)'
    TO__Tonga_ = 'TO (Tonga)'
    TR__Turkish_ = 'TR (Turkish)'
    TS__Tsonga_ = 'TS (Tsonga)'
    TT__Tatar_ = 'TT (Tatar)'
    TW__Twi_ = 'TW (Twi)'
    TY__Tahitian_ = 'TY (Tahitian)'
    UG__Uyghur_ = 'UG (Uyghur)'
    UK__Ukrainian_ = 'UK (Ukrainian)'
    UR__Urdu_ = 'UR (Urdu)'
    UZ__Uzbek_ = 'UZ (Uzbek)'
    VE__Venda_ = 'VE (Venda)'
    VI__Vietnamese_ = 'VI (Vietnamese)'
    VO__Volapük_ = 'VO (Volapük)'
    WA__Walloon_ = 'WA (Walloon)'
    WO__Wolof_ = 'WO (Wolof)'
    XH__Xhosa_ = 'XH (Xhosa)'
    YI__Yiddish_ = 'YI (Yiddish)'
    YO__Yoruba_ = 'YO (Yoruba)'
    ZA__Zhuang_ = 'ZA (Zhuang)'
    ZH__Chinese_ = 'ZH (Chinese)'
    ZU__Zulu_ = 'ZU (Zulu)'


class Title(BaseModel):
    class Config:
        extra = Extra.forbid

    text: constr(min_length=1) = Field(
        ...,
        description='Scientific unabbreviated title or name of the [RESOURCE].',
        example='',
        title='Title/name',
    )
    language: LanguageNamesFromTheISO6391List = Field(
        ...,
        description='Language in which the title/name is provided.',
        example='',
        title='Language of the title/name',
    )


class Acronym(BaseModel):
    class Config:
        extra = Extra.forbid

    text: constr(min_length=1) = Field(
        ...,
        description='If existing, acronym(s) of the [RESOURCE].',
        example='',
        title='Acronym',
    )
    language: LanguageNamesFromTheISO6391List = Field(
        ...,
        description='Language in which the acronym is provided.',
        example='',
        title='Language of the acronym',
    )


class Description(BaseModel):
    class Config:
        extra = Extra.forbid

    text: constr(min_length=1) = Field(
        ...,
        description='Short plain text summary of the [RESOURCE].',
        example='',
        title='Description',
    )
    language: LanguageNamesFromTheISO6391List = Field(
        ...,
        description='Language in which the description text is provided.',
        example='',
        title='Language of the description',
    )


class Population(BaseModel):
    class Config:
        extra = Extra.forbid

    coverage: Optional[Coverage] = Field(
        None,
        description='Specification of the recruitment area of the [RESOURCE].',
        example='',
        title='Coverage',
    )
    countries: List[CountryNamesFromTheISO31661List] = Field(
        ...,
        description='Country or countries where the [RESOURCE] takes place.',
        example='',
        min_items=1,
        title='Country(ies)',
    )
    region: Optional[str] = Field(
        None,
        description='If applicable, region(s) and/or city(ies) within a country where the [RESOURCE] takes place.',
        example='',
        title='Region(s) and/or city(ies)',
    )
    description: Optional[str] = Field(
        None,
        description='Additional descriptive information providing more details about the population of the [RESOURCE].',
        example='',
        title='Population description',
    )
    targetSampleSize: Optional[int] = Field(
        None,
        description='Intended number of observational units for the whole [RESOURCE] (e.g. intended number of [RESOURCE] participants at all sites of the [RESOURCE]).',
        example='',
        title='Target sample size',
    )
    obtainedSampleSize: Optional[int] = Field(
        None,
        description='Obtained number of observational units for the whole [RESOURCE] (e.g. obtained number of [RESOURCE] participants at all sites of the [RESOURCE]).',
        example='',
        title='Obtained sample size',
    )


class Design(BaseModel):
    class Config:
        extra = Extra.forbid

    primaryDesign: Optional[PrimaryDesign] = Field(
        None,
        description='Non-interventional design refers to a [RESOURCE] that does not aim to alter its outcomes of interest. Interventional design refers to a [RESOURCE] that aims to alter its outcomes of interest.',
        example='',
        title='Is it an interventional or non-interventional [RESOURCE]?',
    )
    studyType: Optional[StudyType] = Field(
        None,
        description='Group of items providing information about the type of the [RESOURCE].',
        example='',
        title='Specification of the type of the [RESOURCE]',
    )
    conditions: Optional[List[Condition]] = Field(
        None,
        description='Group of items providing information about primary health condition(s) or disease(s) considered in the [RESOURCE].',
        example='',
        min_items=1,
        title='Primary health condition(s) or disease(s) considered in the [RESOURCE]',
    )
    focus: Optional[List[Focu]] = Field(
        None,
        description='Group of items providing information about the focus of the [RESOURCE] (e.g. medication, food, therapy, device, etc.).',
        example='',
        min_items=1,
        title='Primary focus of the [RESOURCE]',
    )
    groupsOfDiseases: GroupsOfDiseases = Field(
        ...,
        description='Group of items providing information about groups of diseases or conditions on which the data were collected in the [RESOURCE].',
        example='',
        title='Groups of diseases or conditions',
    )
    mortalityData: Optional[MortalityData] = Field(
        None,
        description='Indication whether mortality data are collected in the [RESOURCE].',
        example='',
        title='Collects mortality data?',
    )
    administrativeInformation: Optional[AdministrativeInformation] = Field(
        None,
        description='Group of items providing administrative information about the [RESOURCE].',
        example='',
        title='Administrative information about the [RESOURCE]',
    )
    centers: Optional[Centers] = Field(
        None,
        description='Specification whether the [RESOURCE] is conducted at only one or at more than one [RESOURCE] center.',
        example='',
        title='Mono- or multicentric?',
    )
    centersNumber: Optional[int] = Field(
        None,
        description='Number of centers involved in the [RESOURCE].',
        example='',
        title='Number of centers',
    )
    dataProviders: Optional[DataProviders] = Field(
        None,
        description='Specification whether the [RESOURCE] involves only one or more than one data provider.',
        example='',
        title='One or more data providers?',
    )
    dataProvidersNumber: Optional[int] = Field(
        None,
        description='Number of data providers involved in the [RESOURCE].',
        example='',
        title='Number of data providers',
    )
    subject: Subject = Field(
        ...,
        description='The primary subject addressed by the [RESOURCE], i.e. a person, an animal or other subject types.',
        example='',
        title='Primary subject',
    )
    sampling: Optional[Sampling] = Field(
        None,
        description='Group of items providing information about the applied sampling method.',
        example='',
        title='Sampling method',
    )
    dataSource: Optional[DataSource1] = Field(
        None,
        description='Group of items providing information about data sources from which the data of the [RESOURCE] are generated or extracted.',
        example='',
        title='Data sources of the [RESOURCE]',
    )
    primaryPurpose: Optional[PrimaryPurpose] = Field(
        None,
        description='Specification of the main purpose of the [RESOURCE].',
        example='',
        title='Primary purpose of the [RESOURCE]',
    )
    eligibilityCriteria: Optional[EligibilityCriteria] = Field(
        None,
        description='Group of items providing information about eligibility criteria for [RESOURCE] participants.',
        example='',
        title='Eligibility criteria for [RESOURCE] participants',
    )
    population: Population = Field(
        ...,
        description='Group of items providing information about the population of the [RESOURCE].',
        example='',
        title='Population of the [RESOURCE]',
    )
    hypotheses: Optional[List[str]] = Field(
        None,
        description='Statement of the research questions and/or hypotheses underlying the [RESOURCE].',
        example='',
        min_items=0,
        title='Research questions/hypotheses',
    )
    arms: Optional[List[Arm]] = Field(
        None,
        description='Group of items providing information about the arms of the [RESOURCE].',
        example='',
        min_items=1,
        title='Arms of the [RESOURCE]',
    )
    groups: Optional[List[Group]] = Field(
        None,
        description='Group of items providing information about the groups/cohorts of the [RESOURCE].',
        example='',
        min_items=1,
        title='Groups/cohorts of the [RESOURCE]',
    )
    interventions: Optional[List[Intervention]] = Field(
        None,
        description='Group of items providing information about the interventions of the [RESOURCE].',
        example='',
        min_items=1,
        title='Interventions of the [RESOURCE]',
    )
    exposures: Optional[List[Exposure]] = Field(
        None,
        description='Group of items providing information about the exposures of the [RESOURCE].',
        example='',
        min_items=1,
        title='Exposures of the [RESOURCE]',
    )
    outcomes: Optional[List[Outcome]] = Field(
        None,
        description='Group of items providing information about outcome measures.',
        example='',
        min_items=1,
        title='Outcome measures in the [RESOURCE]',
    )
    comment: Optional[str] = Field(
        None,
        description='Any additional information about specific aspects of the [RESOURCE] that could not be captured by other fields.',
        example='',
        title='Additional information about the [RESOURCE]',
    )
    assessments: Optional[List[Assessment]] = Field(
        None,
        description='Any additional assessments/measurements included in the [RESOURCE].',
        example='',
        min_items=0,
        title='Additional assessments/measurements in the [RESOURCE]',
    )
    dataSharingPlan: DataSharingPlan = Field(
        ...,
        description='Group of items providing information about the data sharing strategy of the [RESOURCE].',
        example='',
        title='Data sharing strategy of the [RESOURCE]',
    )
    nonInterventional: Optional[NonInterventional] = Field(
        None,
        description='Group of items providing information about specific non-interventional aspects of the [RESOURCE].',
        example='',
        title='Non-interventional aspects of the [RESOURCE]',
    )
    interventional: Optional[Interventional] = Field(
        None,
        description='Group of items providing information about specific interventional aspects of the [RESOURCE].',
        example='',
        title='Interventional aspects of the [RESOURCE]',
    )


class Resource(BaseModel):
    class Config:
        extra = Extra.forbid

    collection: Optional[List[str]] = Field(None, min_items=1)
    identifier: constr(min_length=1) = Field(
        ...,
        description='Unique identifier of the resource used for identification within the NFDI4Health.',
        example='',
        title='ID of the [RESOURCE]',
    )
    classification: Classification = Field(
        ...,
        description='Group of items providing information about the classification of the resource within the predefined categories.',
        example='',
        title='Resource classification',
    )
    titles: List[Title] = Field(
        ...,
        description='Group of items providing information about title(s)/name(s) of the [RESOURCE].',
        example='',
        min_items=1,
        title='Title(s)/name(s) of the [RESOURCE]',
    )
    acronyms: Optional[List[Acronym]] = Field(
        None,
        description='Group of items providing information about acronym(s) of the [RESOURCE].',
        example='',
        min_items=1,
        title='Acronym(s) of the [RESOURCE]',
    )
    descriptions: List[Description] = Field(
        ...,
        description='Group of items providing information about the description(s) of the [RESOURCE].',
        example='',
        min_items=1,
        title='Description(s) of the [RESOURCE]',
    )
    keywords: Optional[List[Keyword]] = Field(
        None,
        description='Group of items providing information about keywords describing the [RESOURCE].',
        example='',
        min_items=1,
        title='Keyword(s) describing the [RESOURCE]',
    )
    languages: Optional[List[LanguageNamesFromTheISO6391List]] = Field(
        None,
        description='Language(s) in which the [RESOURCE] is conducted/provided.',
        example='',
        min_items=0,
        title='Language(s) of the [RESOURCE]',
    )
    webpage: Optional[AnyUrl] = Field(
        None,
        description='If existing, a link to the web page directly relevant to the [RESOURCE].',
        example='',
        title='Web page of the [RESOURCE]',
    )
    nonStudyDetails: Optional[NonStudyDetails] = Field(
        None,
        description='Group of items applicable only to resource types other than a study/substudy, a dataset, a registry, or a secondary data source.',
        example='',
        title='Detailed information about the [RESOURCE]',
    )
    contributors: List[Contributor] = Field(
        ...,
        description='Group of items providing information about person(s), group(s) of persons or institution(s)/organisation(s) contributing to the [RESOURCE].',
        example='',
        min_items=1,
        title='Contributor(s) of the [RESOURCE]',
    )
    idsAlternative: Optional[List[IdsAlternativeItem]] = Field(
        None,
        description='Group of items providing information about identifiers (IDs) assigned to the given [RESOURCE] by another registering systems, e.g. a registry of clinical trials or a data repository.',
        example='',
        min_items=1,
        title='Alternative identifiers',
    )
    ids: Optional[List[Id]] = Field(
        None,
        description='Group of items providing information about identifiers (IDs) of the resources related to the given [RESOURCE], e.g. DOIs of publications, datasets, study documents or links to web pages.',
        example='',
        min_items=1,
        title='Related resources',
    )
    idsNfdi4health: Optional[List[IdsNfdi4healthItem]] = Field(
        None,
        description='Group of items providing information about related resources (e.g. (sub-)studies, study documents, etc.) registered on this portal.',
        example='',
        min_items=1,
        title='Related resources registered on this portal',
    )
    provenance: Provenance = Field(
        ...,
        description='Group of items providing information about provenance aspects of the data entry on this portal.',
        example='',
        title='Provenance aspects of data entry',
    )
    nutritionalData: Optional[bool] = Field(
        None,
        description='Indication whether the [RESOURCE] collects nutritional data.',
        example='',
        title='Collects nutritional data?',
    )
    chronicDiseases: Optional[bool] = Field(
        None,
        description='Indication whether the [RESOURCE] addresses chronic diseases.',
        example='',
        title='Includes chronic diseases?',
    )
    design: Optional[Design] = Field(
        None,
        description='Group of items providing information about the characteristics of a [RESOURCE].',
        example='',
        title='Characteristics of the [RESOURCE]',
    )
